import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class TimeTest {

  @Before
  public void setUp() throws Exception {
  }

  @Test
  public void test1() {
    Time d1 = new Time(12,17, 56);
    Time d2 = new Time(12,17, 57);
    assertTrue(d1+" liegt vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  @Test
  public void test2() {
    Time d1 = new Time(12,16, 57);
    Time d2 = new Time(12,17, 57);
    assertTrue(d1+" liegt vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  @Test
  public void test3() {
    Time d1 = new Time(11,17, 57);
    Time d2 = new Time(12,17, 57);
    assertTrue(d1+" liegt vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  @Test
  public void test4() {
    Time d1 = new Time(12,17, 57);
    Time d2 = new Time(12,17, 57);
    assertFalse(d1+" liegt nicht vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  @Test
  public void test5() {
    Time d1 = new Time(12,16, 56);
    Time d2 = new Time(12,17, 5);
    assertTrue(d1+" liegt vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  
  @Test
  public void test6() {
    Time d1 = new Time(11,55, 56);
    Time d2 = new Time(12,17, 5);
    assertTrue(d1+" liegt vor  "+d2,d1.isEarlierThan(d2));
    assertFalse(d1+" liegt nicht nach "+d2,d1.isLaterThan(d2));
  }
  @Test
  public void test7() {
    Time d1 = new Time(11,55, 56);
    Time d2 = d1.minutesLater(1);
    assertEquals("Minute falsch für: new Time(11,55, 56).minutesLater(1);" , 56, d2.minute);
    assertEquals("Stunde falsch für: new Time(11,55, 56).minutesLater(1);", 11, d2.hour);
    assertEquals("new Time(11,55, 56).minutesLater(1);", d2.second, d1.second);
  }
  @Test
  public void test8() {
    Time d1 = new Time(11,55, 56);
    Time d2 = d1.minutesLater(61);
    assertEquals("Minute falsch für: new Time(11,55, 56).minutesLater(61)" , 56, d2.minute);
    assertEquals("Stunde falsch für: new Time(11,55, 56).minutesLater(61)", 12, d2.hour);
    assertEquals("new Time(11,55, 56).minutesLater(61)", d2.second, d1.second);
  }
  @Test
  public void test9() {
    Time d1 = new Time(11,55, 56);
    Time d2 = d1.minutesLater(1+13*60);
    assertEquals("Minute falsch für: new Time(11,55, 56).minutesLater(1+13*60)" , 56, d2.minute);
    assertEquals("Stunde falsch für: new Time(11,55, 56).minutesLater(1+13*60)", 0, d2.hour);
    assertEquals("new Time(11,55, 56).minutesLater(1+13*60)", d2.second, d1.second);
  }
  @Test
  public void test10() {
    Time d1 = new Time(11,55, 56);
    Time d2 = d1.minutesLater(8+13*60);
    assertEquals("Minute falsch für: new Time(11,55, 56).minutesLater(8+13*60)" , 3, d2.minute);
    assertEquals("Stunde falsch für: new Time(11,55, 56).minutesLater(8+13*60)", 1, d2.hour);
    assertEquals("new Time(11,55, 56).minutesLater(8+13*60)", d2.second, d1.second);
  }
/*
	@Test(expected=AssertionError.class)
	public void test11() {
		Time d1 = new Time(11,55, 56);
		Time d2 = d1.minutesLater(-1);
		assertEquals("", 54, d2.minute);
		assertEquals("", 11, d2.hour);
		assertEquals("", d2.second, d1.second);
	}
	*/
}